///////////////////////////////////////////////////////////////////////////////
// FILE : Context.h
// Header file for Personal Information class
// Context Profile
///////////////////////////////////////////////////////////////////////////////

#include <deque>
#include <string>
using namespace std;

#ifndef _CONTEXT_H_
#define _CONTEXT_H_

class Person
{
  
public:
	string participant_type; // organizer,atendee.... 
	string communication_in; // video_audio, text_only, audio_only
	string communication_out; // video_audio, text_only, audio_only
	string communication_id; // id of the participant
	string firstname; // 
	string lastname; //
	string company_name;
	string title;
	
	Person();
	~Person();
	void SetPartType(string text);
	void SetCommIn(string text);
	void SetCommOut(string text);
	void SetCommID(string id);
	void SetFirstName(string text);
	void SetLastName(string text);
	void SetCompanyName(string text);
	void SetTitle(string text);

	string GetPartType(void);
	string GetCommIn(void);
	string GetCommOut(void);
	string GetCommID(void);
	string GetFirstName(void);
	string GetLastName(void);
	string GetCompanyName(void);
	string GetTitle(void);

	void ShowData(void);


};

class Context
{
private: 
	int meeting_id; //identifier of the meeting to get connected to
	int num_attendees; //indicates how many participants are on that communication link
public:
	
	Context();
	~Context();

	deque<Person> lst; //cannot be private if I want to get the info from each participant
	const void IncAttendee(void);
	const void SetMeetID(int id);
	const void SetNoAttend(int no);

	int GetMeetID(void);
	int GetNoAttend(void);


	const void Insert(Person &x);

	void ShowDeque(void);

	FILE* PrintData(void);
};

#endif //