#include "stdafx.h"
#include ".\meetingservicesocketmanager.h"
#include ".\basicxml.h"
enum { TEXT_TEXT, AUDIO_AUDIO, VIDEO_AUDIO, VIDEO_VIDEO };

CMeetingServiceSocketManager::CMeetingServiceSocketManager(void)
{
	meetingStarted = false;
	mySiblings = NULL;
	bSkypeInitialized = false;

}

CMeetingServiceSocketManager::~CMeetingServiceSocketManager(void)
{


}
void
CMeetingServiceSocketManager::setSiblings(CSocketManager *sc)  //method to assign sibling sockets of the same kind--> makes sense if you are a server and have several connection
{
	mySiblings = sc; //only reading it!

}

void 
CMeetingServiceSocketManager::OnDataReceived(const LPBYTE lpBuffer, DWORD dwCount)
{
	LPBYTE lpData = lpBuffer;
	SockAddrIn origAddr;
	stMessageProxy msgProxy;
	if (IsSmartAddressing())
	{
		dwCount = __min(sizeof(msgProxy), dwCount);
		memcpy(&msgProxy, lpBuffer, dwCount);
		origAddr = msgProxy.address;
		if (IsServer())
		{
			// broadcast message to all
			msgProxy.address.sin_addr.s_addr = htonl(INADDR_BROADCAST);
			WriteComm((const LPBYTE)&msgProxy, dwCount, 0L);
		}
		dwCount -= sizeof(msgProxy.address);
		lpData = msgProxy.byData;
	}

	// Display data to message list

	//TO BE CHANGED: here each one, whether server or client--> it would be good to have a class
	//to control de content of the xml file
	//different code for CLIENT and for SERVER


	//TEST
/*
		if (!IsServer())
		{

			BYTE byBuffer[256] = { 0 };
			CString strText("This is a test");

			// Update so that we can retrieve new port number also... :-)
			int nLen = strText.GetLength();

			if (nLen > 0)
			{
				strText += _T("\r\n");
				nLen = strText.GetLength() + 1;
				USES_CONVERSION;
				strcpy((LPSTR)byBuffer, T2CA(strText));
				WriteComm( byBuffer, nLen, 0L);
			}
		}
*/
	DisplayData( lpData, dwCount, origAddr );  //to erase once not needed

	ProcessData( lpData, dwCount, origAddr );




}


void CMeetingServiceSocketManager::ProcessData(const LPBYTE lpData, DWORD dwCount, const SockAddrIn& sfrom)
{
	CString strData;
	char * tmp =  strData.GetBuffer(dwCount); //to have access to the contents directly!!
	memcpy(tmp, A2CT((LPSTR)lpData), dwCount);
	tmp[dwCount]='\0';

	//HERE STARTS THE BUFFERING OF THE COMPLETE MESSAGE SENT 

		//VERY IMPORTANT: \r\n indicates the end of the file or info that has been sent!!
		//send() from sockets will not send everything at once --> we need to control the end of the information

		//as long as I do not receive the \r\n I do not process anything, the info is not done
		//so I have to concat

	static char buffer[1024] = {'\0'}; //for the tests I give this value
	strcat(buffer,tmp);
	
	strData.ReleaseBuffer(); //to make sure  that we can use other CString methods tmp will be null from now on

	

	//MessageBox(NULL, buffer, "", MB_OK);


	if(strData.Find(CString("\r\n"))== -1) //we did not find it and we keep on buffering
	{
		return;
	}


	//HERE STARTS THE PROCESSING OF THE MESSAGE AFTER BEING BUFFERED

	CString sBuffer(buffer);

	//I am using an intermediate file to be able to read xml
	FILE * f = fopen("tmp.xml", "w");

	writeCompleteFile(f, buffer);

	fclose(f); //It does not do it at once I have to check what send from sockets does!!!

	f = fopen("tmp.xml","rt");

	if(NULL==f)
	{
		MessageBox(NULL, "I could not open tmp.xml", "", MB_OK);
		buffer[0]='\0';

		return;
	}
			
	basicxmlnode  *XML;
	XML=basicxmlnode::ReadBasicxmlnode(f);

	Context conx;
	Person pers;
	SCommand scomm;
	Commands command;

	//MessageBox(NULL,"Reading contents XML file", "", MB_OK);

	basicxmlnode::BasicXmlnodeToContext(XML, conx, pers, command, scomm);

	//check if what we got is a command 
	if(command.Num_Commands!=0)
	{
		if(!IsServer()) //command processing for the CLIENT
		{

			//process command
			if(command.CommandLst[0].CommandName.compare("start_chat")==0)
			{
				meetingStarted = true;  //for chat it is centralized on the server for the moment
			}
		}

		if(IsServer()) //command processing for the SERVER
		{
			if(meetingStarted)
			{
				if(command.CommandLst[0].CommandName.compare("start_vote_regitration")==0)
				{
					meetingStarted = true;  //for chat it is centralized on the server for the moment
					//To be implemented
					//reach all other threads from current thread if possible, broadcast the message
					//for the demo I just send it back to who has contacted me
				}
			}
			else
			{
				//control the errors due to sending commands at wrong moments
			}


		}

	}

	else if(conx.GetNoAttend()!=0)  //we have a content XML
	{

		//process the initialization of the meeting if you are a server I guess
		string paramInput = conx.lst[0].communication_in; //from the first and only participant: for the time being
		string paramOutput = conx.lst[0].communication_out;

		int casus = -1;


		if(paramInput.compare("text") == 0 && paramOutput.compare("text")==0)			
		{
			casus = TEXT_TEXT;
		}

		if(IsServer())  //Processing the xml on the server side
		{
			switch(casus)
			{
			case TEXT_TEXT:
				{
					//MessageBox(NULL, "It worked!!", "", MB_OK);
				//CASE ONLY TEXT AND SESSION INITIALIZATION:
				//special case where it is the server that deals with the communications

					if(!Skype.init())
					{
						MessageBox(NULL, "ERROR: could not initiliaze Skype", "", MB_OK);
		
					}
				
					Skype.setOpenChatWindow(true);
					bSkypeInitialized = true;
				
					string chat_id = conx.lst[0].communication_id;
					Skype.startChat(chat_id.c_str());

					f = fopen("start_chat.xml", "r");
					if(NULL==f)
					{
						MessageBox(NULL, "I couldn't open start_chat xml file", "", MB_OK);
						buffer[0]='\0';
						return;
					}
					//send the command to the one in the chat

					char buffer2[5000]; //very long buffer to make sure that we do not leave anything aside

					if(readCompleteFile(f,buffer2))
					{
						writeStringOnSocket(buffer2);
					}

					meetingStarted = true;
					fclose(f);
				}
				break;
			default:
				break;
			}


		}//end xml processing for the SERVER
		


	}
	else
	{
		if(!IsServer()) //EXTERNAL PROCESSING for the CLIENT
		{
		//it is a keyboard or external console command
			if(!meetingStarted)
			{
				//MessageBox(NULL, "I Inside MeetingStarted","",MB_OK);

				if(sBuffer.CompareNoCase(CString("Start\r\n"))==0)
				{
					//MessageBox(NULL, "I have received the start Command","",MB_OK);
					StartMeetingConnection();
					 meetingStarted = true;

				}
			 	buffer[0]='\0';

			 return;
			}

		}// end of the server processing

		if(IsServer()) //EXTERNAL PROCESSING for the SERVER
		{
			if(meetingStarted)
			{

				if(strData.Compare(CString("VM\r\n"))==0)
				{
					//MessageBox(NULL, "I have received the vote Command","",MB_OK);
					StartVoteRegistrationMode(); 
				}
				buffer[0]='\0';

				 return;
			}


		}

	}// end of external commands




		/*
		//CASE ONLY TEXT AND SESSION INITIALIZATION:

		if(!Skype.init())
		{
			MessageBox(NULL, "ERROR: could not initiliaze Skype", "", MB_OK);
		}

		Skype.setOpenChatWindow(true);
		Skype.startChat("bosphorus_7");
 
		//CASE ONLY TEXT AND VOTE REGISTRATION MODE:
		
		//Example multiplechoice questions
		

		cTextVote a;
		a.setQuestion(string("What color do you prefer?"));  //string class incompatible with MFC in DEBUG mode
		a.setBinary(false);
		
		string *opt = NULL;
		opt = new string[4];

		opt[0]="blue";
		opt[1]="green";
		opt[2]="red";
		opt[3]="none";
		a.setOptions(opt,4);

		Skype.textVoteRegistration(a);
/**/		
		//CASE SINGLE FACE VIDEO AND VOTE REGISTRATION MODE:
/*
		cSingleFaceVideoVote sFaceVideoVote;
		sFaceVideoVote.bDisplayWindow=true;
		sFaceVideoVote.setQuestion(string("Do you want some coffee?"));
		sFaceVideoVote.setBinary(true);
		sFaceVideoVote.setIPCamAddress(string("http://10.112.38.188/cgi-bin/video.jpg?size=2"));
*/
		//test with the WebCam
		/*
		CWebCamInput webCam;
		webCam.singleFaceVoteRegistration(sFaceVideoVote);
		*/

		//test with the IPCam
/*
		CIPCamInput IpCam(string("http://10.112.38.188/cgi-bin/video.jpg?size=2"));
		IpCam.singleFaceVoteRegistration(sFaceVideoVote);
*/

		//CASE ONLY_AUDIO AND SESSION INITIALIZATION:
/*
		if(!Skype.init())
		{
			MessageBox(NULL, "ERROR: could not initiliaze Skype", "", MB_OK);
		}

		Skype.startCall("bosphorus_07", "bosphorus_08");

		Sleep(10000);

		//CASE ONLY_AUDIO AND VOTE REGISTRATION MODE:

		Skype.putCallOnHold();

		//here goes the audio exchange code
		Sleep(10000);
		Skype.resumeCall();
 
/**/	

		//CASE ONLY_AUDIO AND VOTE REGISTRATION MODE:

	//	Skype.closeup();
//	}



	buffer[0]='\0';
}


void CMeetingServiceSocketManager::StartMeetingConnection()
{
	if(IsServer())				//code to manage the server
	{
		
		//we connect from the client

		return;
	}



	FILE * f = fopen("participant.xml", "r");

	if (f==NULL)
	{
		MessageBox(NULL,"File not found","ERROR", MB_OK); 
		return;
	}

	//create context object
	//read the content of simple and write it down on a String
	//think what to do with its contents: send it the

	char buffer[5000]; //very long buffer to make sure that we do not leave anything aside

	if(readCompleteFile(f,buffer))
	{
		writeStringOnSocket(buffer);

	}

}
	



bool CMeetingServiceSocketManager::readCompleteFile(FILE *f, char * str)
{
	//make sure that str is long ENOUGH!!!!
	str[0] = '\0'; //we initialize the output string

	char buffer[500];
	while(fgets(buffer, 500, f)!=NULL)
	{
		strcat(str,buffer);
	}

	if(feof(f))
		return true;
	if(ferror(f))
		return false;

}

bool CMeetingServiceSocketManager::writeStringOnSocket( char * str)
{
		BYTE byBuffer[5000] = { 0 };
		//CString strText(str);
		//int nLen = strText.GetLength();
		int nLen = 0;


				//if (nLen > 0)
			if(str!=NULL)
			{
					//strText += _T("\r\n");
					strcat(str,"\r\n");
					//nLen = strText.GetLength() + 1;
					//USES_CONVERSION;
					//strcpy((LPSTR)byBuffer, T2CA(strText));
					nLen = strlen(str);
					DWORD a = WriteComm((BYTE *)str, nLen, 0L);
					//if(a>=nLen) return true;
					//else return false;
					return true; 
				}

				return false;


}

void CMeetingServiceSocketManager::StartVoteRegistrationMode()
{

	if(IsServer())				//code to manage the server
	{
		
		//return;//we will design this later

		//for the chat the process starts at the server
		if(!bSkypeInitialized)
		{
			if(!Skype.init())
			{
				MessageBox(NULL, "ERROR: could not initiliaze Skype", "", MB_OK);

			}
		}

		//THIS HAS TO BE SUBSTITUTED BY READING FROM THE SOCKET THAT CONTAINTS THE XML WITH THE QUESTIONS
		//IN THE VOTE COMMAND --> knowing that it will just be a local file and that it is simulated
		cTextVote a;
		a.setQuestion(string("What color do you prefer?"));  //string class incompatible with MFC in DEBUG mode
		a.setBinary(false);
		
		string *opt = NULL;
		opt = new string[4];

		opt[0]="blue";
		opt[1]="green";
		opt[2]="red";
		opt[3]="none";
		a.setOptions(opt,4);

		Skype.textVoteRegistration(a);

		string finalResult = "Participant 1 has chosen: " + a.getChoice();
		

		DisplayData((LPBYTE)(&finalResult.at(0)), finalResult.length(), SockAddrIn());

	
		

	}

	else{

			//we will see what the client will have to do
			//when dealing with audio and video media the processing will be here

	}


//Code to send in broadcast to everyone: it is not correct
	
/*
	FILE * f = fopen("VRcommand.xml", "r");

	if (f==NULL)
	{
		MessageBox(NULL,"File not found","ERROR", MB_OK); 
		return;
	}

	//create context object
	//read the content of simple and write it down on a String
	//think what to do with its contents: send it the

	char buffer[5000]; //very long buffer to make sure that we do not leave anything aside

	if(readCompleteFile(f,buffer))
	{
		//writeStringOnSocket(buffer);
		sendToEveryone(buffer);

	}
*/

}


//I HAVE A PROBLEM!!!
bool CMeetingServiceSocketManager::sendToEveryone( char *str)  //it does not work --. we are a thread
{
	bool result = true;
	if(mySiblings!=NULL)
	{

		for(int i=0; i<10; i++)  //make MAXCONNECTION=10 A STATIC OF THE CLASS!!
			{
				//MessageBox(NULL, "I am inside the loop", "", MB_OK);
				if (mySiblings[i].IsOpen())
				{
					BYTE byBuffer[5000] = { 0 };
					CString strText(str);
					// Update so that we can retrieve new port number also... :-)
					int nLen = strText.GetLength();
					if (nLen > 0)
					{
						strText += _T("\r\n"); //only needed if I want to display it, otherwise it is not needed
						nLen = strText.GetLength() + 1;
						USES_CONVERSION;
						strcpy((LPSTR)byBuffer, T2CA(strText));
						DWORD a = 	mySiblings[i].WriteComm(byBuffer, nLen, 0L);
			//WriteComm( byBuffer, nLen, 0L);
						if(a<nLen) result = false;
					}
				}
			}
	}
	else
	{
		//return something or error or whatever
	}

	return result;
}

bool CMeetingServiceSocketManager::writeCompleteFile(FILE *f, char * str)
{
	//make sure that str is long ENOUGH!!!!

	int num = fputs(str, f);
	while(num!=0)
	{
		num=fputs(str+num,f);
	}

	/*if(str[num]='\0')
		return true;
	else
		return false;
*/
	return true; //for the time being
}
