#include "stdafx.h"
#include ".\skype.h"



cSkype::cSkype(void)
{
	pChat = NULL;
	pSkype = NULL;
	pCall = NULL;
	openChatWindow = true;

}

cSkype::~cSkype(void)
{
}


bool 
cSkype::init(){
	//SKYPE code - Skype should be initialized only once
	CoInitialize(NULL);
	ISkypePtr pSkype2(__uuidof(Skype));
	pSkype = pSkype2;

	//MessageBox(NULL, "Inside Init()", "info", MB_OK);
	if(pSkype == NULL)
	{
		MessageBox(NULL, "ERROR: Skype was not initialized", "info", MB_OK);
		return false;
	}
	


 // Connect to API
	//check what it returns if successful
	pSkype->Attach(7,VARIANT_TRUE); //if error ask to switch on Skype!!! --> you have to run it first
	return true;
}


void 
cSkype::closeup(){
	//Skype code
	CoUninitialize();
	//Skype code



}

bool 
cSkype::startChat(const char * id){
	pChat = pSkype->CreateChatWith(id);
	if(pChat==NULL)
		return false;

	//pSkype->ClearChatHistory();   //causes the application to crush if there are no previous messages!

	if(openChatWindow)
		pChat->OpenWindow();

	return true;
}


void 
cSkype::textVoteRegistration(cTextVote &a){


	//MessageBox(NULL,"Inside skype vote registration", "", MB_OK);

	string test = a.getQuestion();
	string * option = a.getOptions();

 
	string message= a.getQuestion();
	
	for(int i=0; i<a.getNumOptions(); i++)
		message = message+ "; "+a.getOptions()[i];

	if(pChat==NULL)
	{
		//get the pointer to the first chat we assume is the only one active
		//theoretically if both start a chat with each other they end on the same object!!
		//but just in case
		IChatCollectionPtr pActiveChat = pSkype->GetActiveChats();
		pChat = pActiveChat->GetItem(1); //we asume one call for the test
	}
	if(pChat==NULL)
		return;  //this is an error
	
	pChat->SendMessage(&message.at(0));
	pSkype->PutCache(false); //to do when entering vote_registration mode
	bool finished = false;
	
	while (!finished)
	{
		
		IChatMessageCollectionPtr pChatMessColl = pChat->GetMessages();  //from most recent to first
		
		while(message.compare(string((char*) pChatMessColl->GetItem(1)->GetBody()))==0)  //we compare the last message
		{
			pChatMessColl = pChat->GetMessages();
		}
		
		a.setChoice(string((char*) pChatMessColl->GetItem(1)->GetBody()));
		if(a.verifyChoice())
		{
			message = "You have chosen: " + a.getChoice() + ". Do you want to keep your vote? y/n"; //optional
			pChat->SendMessage(&message.at(0)); //optional
			message = a.UpToLow(message);  //lower case to make sure comparison is ok
			pChatMessColl = pChat->GetMessages();
			
			string input = string((char*) pChatMessColl->GetItem(1)->GetBody());
			input = a.UpToLow(input);
		
			while(string("y").compare(input)!=0&&
				string("yes").compare(input)!=0&&
				string("n").compare(input)!=0&&
				string("no").compare(input)!=0)  //we compare the last message
			{
				if(message.compare(input)!=0)
				{
					message = "pardon?"; //optional: be careful: lower case
					pChat->SendMessage(&message.at(0)); //optional
				}
				pChatMessColl = pChat->GetMessages();
				input = string((char*) pChatMessColl->GetItem(1)->GetBody());
				input = a.UpToLow(input);
				
			}

			if(string("n").compare(input)==0||
				string("no").compare(input)==0)
			{
				finished = false;
				message = "Please, vote again"; //optional
				pChat->SendMessage(&message.at(0)); //optional
			}
			else
				finished = true;
		}
		else
		{
			message = a.getChoice() + ": This is not a valid option. Could you vote again?";
			pChat->SendMessage(&message.at(0));
			finished = false;
		}
	}



	pSkype->PutCache(true); //to do right after exiting vote_registration mode
	//printf("We reached the end of the vote_registration");


	//Skype code

}

bool 
cSkype::getOpenChatWindow()
{
	return openChatWindow;
}


void 
cSkype::setOpenChatWindow(bool b)
{

	openChatWindow = b;

}



bool 
cSkype::startCall(char *id, char *id2)
{
	pCall = pSkype->PlaceCall(id, id2, "", "");  //call to three people

	if(pCall == NULL)
		return false;
	
	return true;


} //for the test we will wait until the two audio speakers are on

void 
cSkype::putCallOnHold()
{
	ICallCollectionPtr pActiveCall = pSkype->GetActiveCalls();
	pCall = NULL;
	pCall = pActiveCall->GetItem(1); //we asume one call for the test
	if (pCall)
		pCall->Hold();
	else
	{//nothing for now
	}
	
};

void 
cSkype::resumeCall()
{

	ICallCollectionPtr pActiveCall = pSkype->GetActiveCalls();
	pCall = pActiveCall->GetItem(1); //we asume one call for the test
	if (pCall)
		pCall->Resume();
	else
	{ //nothing for the moment
	}
	
};
