#include "stdafx.h"
#include ".\csinglefacevideovote.h"
#include <urlmon.h>

cSingleFaceVideoVote::cSingleFaceVideoVote(void):cTextVote()
{
		//to control the input
	bWebCam=true;
	bIPCam = false;
	//binary question? --> default yes for the time being we only have the binary case!!
	setBinary(true);

	bDisplayWindow = true; //by default we show what is being analyzed


	storage = 0;

	// Defining face as a Haar Object
	cascade = 0;
	cascade_name = "haarcascade_frontalface_alt.xml";

	// Some stupid Images
	image = 0, grey = 0, prev_grey = 0, pyramid = 0, maskef = 0, prev_pyramid = 0,maske = 0, swap_temp;

	//Some stupid variables
	win_size = 30;
	MAX_COUNT = 30;
	points[0] = 0;
	points[1] = 0;
	status = 0;
	count = 0;
	need_to_init = 0;
	need_to_detect = 0;

	night_mode = 0;
	flags = 0;

	
}

cSingleFaceVideoVote::cSingleFaceVideoVote(string IPCam):cTextVote()
{
		//to control the input
	bWebCam=false;
	bIPCam = true;

	sIPCamAddress = IPCam;

	//binary question? --> default yes for the time being we only have the binary case!!
	setBinary(true);

	bDisplayWindow = true; //by default we show what is being analyzed


	storage = 0;

	// Defining face as a Haar Object
	cascade = 0;
	cascade_name = "haarcascade_frontalface_alt.xml";

	// Some stupid Images
	image = 0, grey = 0, prev_grey = 0, pyramid = 0, maskef = 0, prev_pyramid = 0,maske = 0, swap_temp;

	//Some stupid variables
	win_size = 30;
	MAX_COUNT = 30;
	points[0] = 0;
	points[1] = 0;
	status = 0;
	count = 0;
	need_to_init = 0;
	need_to_detect = 0;

	night_mode = 0;
	flags = 0;

	
}
cSingleFaceVideoVote::~cSingleFaceVideoVote(void)
{
}


// Holy Main
int
cSingleFaceVideoVote::startFaceVoteAnalysis()
{
	//two vote registration modes: binary and multiple choice

	if(bBinary)
	{
		// Capture from USB
		IplImage* starter = 0;
		CvCapture* capture = 0;
		CvPoint centroid;
		CvPoint centroidold;

		int xmotpoints[1000];
		int ymotpoints[1000];

		int pp = 0;
		int jj;
		int xtot= 0;
		int ytot= 0;
		

		centroidold.x = 0;
		centroidold.y = 0;

		if(bWebCam)
		{
			capture = cvCaptureFromCAM(-1);
		}
		else if(bIPCam)
		{
			//else: there is no initialization required at this point
		}
		else
		{
			//error: 
			return -1;
		}
		
		if( !capture )
		{
			fprintf(stderr,"Could not initialize web capturing...\n");    
		}
		
		printf( "You can try to press ESC to get rid of me !!!\n");
		
		if(bWebCam)
		{
			//remove starting frames where camera does setup--> only needed for tests
			
			starter = cvQueryFrame( capture );
			starter = cvQueryFrame( capture );
			starter = cvQueryFrame( capture );
		}

		// Display Window
		if(bDisplayWindow)
			cvNamedWindow( "Deadly", 1 ); // create window
	 



		// Initialize Tracking Points
		need_to_init = 1;
		
		// Detect Face
		need_to_detect = 1;
		
		// Infinite Looooooooooooooooop
		bool done =  false;
		int counter = 0;
		while(!done )
		{
			
			int i, k, c;
			int sumxnew = 0;
			int sumynew = 0;
			
			
			// Capture a frame
			IplImage* frame, *frame_copy = 0;
	       
			if(bWebCam)
			{
				frame = cvQueryFrame( capture );
			}
			else if(bIPCam)
			{
				//need two things: 
				//(1) save image from URL to file --> to be changed to memory eventually
				//(2) read it from that file into a Image
			//	MessageBox(NULL, "FIRST IMAGE from IPCam", NULL, MB_OK);
				URLDownloadToFile(NULL, (LPCTSTR)sIPCamAddress.c_str(),"temp.jpg",0,NULL); 
                frame = cvLoadImage("temp.jpg",1);
			}

			if( !frame )
				break;
			
			
			// Detect a Face to initialilze the initial face location
			if(need_to_detect)
			{
				
				if( !frame_copy )
					frame_copy = cvCreateImage( cvSize(frame->width,frame->height),
					IPL_DEPTH_8U, frame->nChannels );
				if( frame->origin == IPL_ORIGIN_TL )
					cvCopy( frame, frame_copy, 0 );
				else
					cvFlip( frame, frame_copy, 0 );
	            
				detect_and_draw( frame_copy );
				cvReleaseImage( &frame_copy );
				need_to_detect = 0;
				
			}
			
			// If you just started our program initialize some Images and buffers
			//since using optical flow if no previous frames already exist we have to create the storage
			if( !image )
			{
	            
				image = cvCreateImage( cvGetSize(frame), 8, 3 );
				image->origin = frame->origin;
				grey = cvCreateImage( cvGetSize(frame), 8, 1 );
				maskef= cvCreateImage( cvGetSize(maske), 8, 1 );
				prev_grey = cvCreateImage( cvGetSize(frame), 8, 1 );
				pyramid = cvCreateImage( cvGetSize(frame), 8, 1 );
				prev_pyramid = cvCreateImage( cvGetSize(frame), 8, 1 );
				
				points[0] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
				points[1] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
				status = (char*)cvAlloc(MAX_COUNT);
	            
				flags = 0;
			}
			
			cvCopy( frame, image, 0 );
			cvCvtColor( image, grey, CV_BGR2GRAY );
			
			// Use mask from Face detection to select good points to track
			if( need_to_init )
			{ 
				
				IplImage* eig = cvCreateImage( cvGetSize(grey), 32, 1 );
				IplImage* temp = cvCreateImage( cvGetSize(grey), 32, 1 );
				
				double quality = 0.01;
				double min_distance = 10;
				
				
				count = MAX_COUNT;
				
				cvFlip( maske, maskef, 0 );
				cvGoodFeaturesToTrack( grey, eig, temp, points[1], &count,
					quality, min_distance,maskef, 3, 0, 0.04 );
				
				cvFindCornerSubPix( grey, points[1], count,
					cvSize(win_size,win_size), cvSize(-1,-1),
					cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03));
				cvReleaseImage( &eig );
				cvReleaseImage( &temp );
				need_to_init = 0;
				
				
	            
			}
			
			// If count (no of tracking point) exists start tracking
			else if( count > 0 )
			{
				
				// Calcluate new position using Lucan Kanade algo
				cvCalcOpticalFlowPyrLK( prev_grey, grey, prev_pyramid, pyramid,
					points[0], points[1], count, cvSize(win_size,win_size), 3, status, 0,
					cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03), flags );
				
				flags |= CV_LKFLOW_PYR_A_READY;
	            
				for( i =0; i < count; i++ )
				{	
					sumxnew += cvPointFrom32f(points[1][i]).x;
					sumynew += cvPointFrom32f(points[1][i]).y;
				}
				
				for( i = k = 0; i < count; i++ )
				{
					if( !status[i] )
						continue;
	                
					points[1][k++] = points[1][i];
					
					// Draw tracking points
					cvCircle( image, cvPointFrom32f(points[1][i]), 3, CV_RGB(0,0,255), -1, 8,0);
									
				}
				// sumxnew, sumynew, sumxold, sumyold;
				
				centroid  = cvPoint(sumxnew/count,sumynew/count);
				//cvCircle(image,centroid,3,CV_RGB(255,0,0),-1,8,0);
				
				if (centroidold.x == 0)
				{	centroidold.x = centroid.x;
					centroidold.y = centroid.y;
				}
				
				//printf("%d\t%d \n",centroid.x,centroid.y );
				
				count = k;
			}
			
			
			CV_SWAP( prev_grey, grey, swap_temp );
			CV_SWAP( prev_pyramid, pyramid, swap_temp );
			CV_SWAP( points[0], points[1], swap_points );

			if(bDisplayWindow)
				cvShowImage( "Deadly", image ); // display image
			
			if(abs(centroidold.x - centroid.x) >0 || abs(centroidold.y - centroid.y) >0 ) 
			{
				//printf("%d",pp);
				//printf("motion");
				xmotpoints[pp] = centroid.x;
				ymotpoints[pp] = centroid.y;
				pp++;

				
			}


			centroidold.x = centroid.x;
			centroidold.y = centroid.y;
			

			
			// Controller
			c = cvWaitKey(10);
			if( (char)c == 27 )
				break;
	        
			counter++;
			if(counter>100)  //at 25 fps we have 4 secs we analyze at least 
				done = true;
		}
		
		//printf("done\n");

		for( jj =1; jj < pp-1; jj++ )
			
		{	
			xtot += abs(xmotpoints[jj+1] - xmotpoints[jj]);
			ytot += abs(ymotpoints[jj+1] - ymotpoints[jj]);

		//	printf("%d\t%d\n",xmotpoints[jj],ymotpoints[jj]);

		}

		
		//printf("final %d\t%d\n",xtot,ytot);
		
		if (xtot>ytot)
		{
			//we have registered a negative vote
			setChoice("no");
            printf("\nNop...\n");
		}
		else
		{
			//we have registered a positive vote
			setChoice("yes");
			printf("\nYaaaa...\n");
		}

		if(bWebCam)
		{
			cvReleaseCapture( &capture );
		}

		if(bDisplayWindow)
			cvDestroyWindow("Deadly"); // destroy window
	}	
    return 0;
}


// Face detection function
void 
cSingleFaceVideoVote::detect_and_draw( IplImage* img )
{
	
    double scale = 1.3;  //scale in window search which influences the face search speed
	
	IplImage* gray = cvCreateImage( cvSize(img->width,img->height), 8, 1 );
	IplImage* small_img = cvCreateImage( cvSize( cvRound (img->width/scale),cvRound (img->height/scale)),8, 1 );
	
    int i,j;
	CvScalar s;
	
	maske = cvCreateImage( cvGetSize(img), 8, 1 );
	cascade = (CvHaarClassifierCascade*)cvLoad( cascade_name, 0, 0, 0 );
    storage = cvCreateMemStorage(0);
	
    cvCvtColor( img, gray, CV_BGR2GRAY );
    cvResize( gray, small_img, CV_INTER_LINEAR );
    cvEqualizeHist( small_img, small_img );
	
	
    cvClearMemStorage( storage );
	
    if( cascade )
    {
        
		CvPoint pt1, pt2;
		CvSeq* faces = cvHaarDetectObjects( small_img, cascade, storage,1.1, 2, 0,cvSize(30, 30) );
		CvRect* r;
		
        r = (CvRect*)cvGetSeqElem(faces,0);
        
		if (!r)
		{
			printf("I dont like you because you dont have a face !!!\n ");
			return;	
			
		}		
		
		pt1.x = cvRound((r->x)*scale);
		pt1.y = cvRound((r->y)*scale);
		pt2.x = cvRound((r->x + r->width)*scale);
		pt2.y = cvRound((r->y + r->height)*scale);
		
		cvRectangle( img, pt1, pt2, CV_RGB(255,0,0), 2,8,0 );
		
		// Definig Mask 
		s.val[0]=0;	
		for( i = 0; i < cvGetSize(img).height; i++ ) 
		{
			for( j = 0; j < cvGetSize(img).width; j++ ) 
			{
				cvSet2D(maske,i,j,s);
			}
		}
		
		s.val[0]=1;
		
		for( i = pt1.x; i < pt2.x; i++ ) 
		{
			for( j = pt1.y; j < pt2.y; j++ ) 
			{
				cvSet2D(maske,j,i,s); 
			}
		}
		
		
    }
	
	cvSaveImage("FaceDetect.jpg", img); 
    cvReleaseImage( &gray );
    cvReleaseImage( &small_img );
}



void 
cSingleFaceVideoVote::setIPCamAddress(string IPCam)
{
	
	sIPCamAddress = IPCam;
	bIPCam = true;
	bWebCam = false;
}

string 
cSingleFaceVideoVote::getIPCamAddress()
{
	return sIPCamAddress;
}


