#include "StdAfx.h"
#include ".\cvoteregistration.h"

cVoteRegistration::cVoteRegistration(void)
{

	setStartAnnounce("Entering Vote Registration");
	setEndAnnounce("Exiting Vote Registration");
}

cVoteRegistration::cVoteRegistration(cTextVote ctv)
{
	setStartAnnounce("Entering Vote Registration");
	setEndAnnounce("Exiting Vote Registration");

	
	setReferenceVote(ctv);
}

cVoteRegistration::~cVoteRegistration(void)
{
}

void 
cVoteRegistration::addVote(cTextVote ctv)
{
	dVotes.push_back(ctv);
		
		
};

void cVoteRegistration::setReferenceVote(cTextVote ctv)
{

	referenceVote.setBinary(ctv.getBinary());
	referenceVote.setOptions(ctv.getOptions(),ctv.getNumOptions());
	referenceVote.setQuestion(ctv.getQuestion());
	referenceVote.setChoice("");


}


string 
cVoteRegistration::countVotes()
{

	if(referenceVote.getNumOptions()!=0)
	{
		partialResults = new int[referenceVote.getNumOptions()];

		maxIndex = -1;
		maxQuantity = 0;

		for(int i=0; i<referenceVote.getNumOptions(); i++)
			partialResults[i]=0;

		string * options = referenceVote.getOptions();

		for(int i=0; i<dVotes.size(); i++)
		{
			for(int j=0; j<referenceVote.getNumOptions(); j++)
			{
				if(dVotes[i].getChoice().compare(options[j])==0)
				{
					partialResults[j]++;
					if(partialResults[j]>maxQuantity)
					{
						maxQuantity = partialResults[j];
						maxIndex = j;
					}
				}

			}
		}
		result = options[maxIndex];
		return options[maxIndex];
	}

	result = "ERROR";
	return "ERROR";

			
};

string 
cVoteRegistration::announceStartVoteRegistrationMode()
{
	return startAnnounce;

};
	
string 
cVoteRegistration::announceEndVoteRegistrationMode()
{
	return endAnnounce;

};

void 
cVoteRegistration::setStartAnnounce(string str)
{
	startAnnounce = str;

};
	
void 
cVoteRegistration::setEndAnnounce(string str)
{
	endAnnounce = str;

};
void
cVoteRegistration::setResult(string s)
{
	result = s;
};

string
cVoteRegistration::getResult()
{
	return result;

};