
#include "amifc_audio.h"


amifc_audio::amifc_audio(void):textToSpeech(),speechRec()
{
	/*string *opt=getOptions();
	int nbr=getNumOptions();
	bool b=speechRec.init(opt,nbr, 1, 16000, 128, p);*/
	//param *p;
}

amifc_audio::~amifc_audio(void)
{
}

bool amifc_audio::reco_init(float seconds, int sample_rate, int frames_per_buffer,param *p)
{
	string *opt=getOptions();
	int nbr=getNumOptions();
	//param *p;
	bool b=speechRec.init(opt,nbr, seconds, 0, sample_rate, frames_per_buffer, p);//intialisation of portaudio (for the audio acquisition) and ear (for speech recognition). Please let sample_rate to 16000 for the moment.
	return b;
}

HRESULT amifc_audio::tts(void)
{
  string *opt=getOptions(),q=getQuestion();
  int nbr=getNumOptions();
  string toplay;
  textToSpeech.make_question(q,opt,nbr,&toplay); //building the string that will be played (question, then options, then "please vote")
  HRESULT hr=textToSpeech.play(&toplay); //playing this string
  return hr;
}

void amifc_audio::close_audio_devices()
{
speechRec.close_pa(); //closing portaudio
 speechRec.close_ear(); //closing ear
}

results amifc_audio::reco(float seconds, int sample_rate, int frames_per_buffer,param *p)
{
 results s=speechRec.do_rec(seconds, sample_rate,frames_per_buffer,p); //launching audio acquisition during "first argument" seconds. Then performing the speech recognition. "Second argument" is "frames_per_buffer" and should have the same value as in "init", "third argument" is the sample rate, to keep at 16000 for the moment. 
 return s;
 /*setChoice(UpToLow(s)); //setting the recognized word as choice
 
	 //display the result
 if(verifyChoice())
	{
	 string resultat=getChoice();
	 resultat=UpToLow(resultat);
	 const char *c=resultat.c_str();
	 printf("\nChoice: %s",c); 
	 return true;
	 }
 else
	 {
	 printf("\nNo choice recognized");
	 return false;
	 }*/

}

results amifc_audio::process_results(float seconds,results res, int sample_rate, int frames_per_buffer, param *p)
{
 results output;
 unsigned int length;
 //EarReturncode rc;
 string s, resultat;
 char *temp=(char*)malloc(200*sizeof(char));
 const char *c;
 output.confidence=0;
 output.word="go";
 setChoice(UpToLow(res.word)); //setting the recognized word as choice
 bool yesno_answer=false;
 bool binary=getBinary();
 while((!yesno_answer)&&((!verifyChoice())||((res.confidence<0.5)&&!((res.confidence*output.confidence>0.05)&&(!strcmp(output.word.c_str(),res.word.c_str()))))))
 {
	 if(binary)
	 {
		 while(res.confidence<0.05)
		 {
		 s="Sorry I did not hear your answer. Please say yes or no.";
		 textToSpeech.play(&s);
		 res=reco(seconds,sample_rate, frames_per_buffer,p);
		 }
		 setChoice(UpToLow(res.word));
		 free(temp);
		 return res;
	 }
	 if(res.confidence<=0)
	 {
		   //printf("\nSorry, I did not understand, please vote again\n");
		   s="Sorry I did not understand, please vote again\n";
	 }
	 else
	 {
		if(!verifyChoice())
		 {
		   resultat=getChoice();
		   c=resultat.c_str();
		   //printf("\nA word was recognized (%s), but it does not correspond to one of the possibilities.\n Please vote again\n",c);
		   s="A word was recognized, but it does not correspond to one of the possibilities.\n Please vote again";
		 }
		 else
		 { 
			if(res.confidence>0.1)
					{
					 resultat=getChoice();
					 c=resultat.c_str();
					 //printf("\nSorry, I am not sure I understood well. It seems me you voted for %s (confidence: %f). \nIs that exact? Please answer yes or no.\n",c,res.confidence); 
					 s="Sorry, I am not sure I understood well. It seems me you voted for ";
					 strcpy(temp,s.c_str());
					 s=strcat(temp,c);
					 strcpy(temp,s.c_str());
					 s=strcat(temp,". \nIs that exact? Please answer yes or no.");
					 speechRec.app=speechRec.MapBinaryFileToMem("yesno.app",&length);
					 speechRec.rc=EarReadVocabulary(speechRec.ear, speechRec.app);                      // load grammatical model
					 yesno_answer=true;
					 //return 2;
					 }
				 else
					 {
					 resultat=getChoice();
					 c=resultat.c_str();
					 //printf("\nSorry, it is very likely I did not understand properly (choice: %s, confidence: %f). \nCan you please repeat your choice now?\n",c,res.confidence);
					 s="Sorry, it is very likely I did not understand properly. \nCan you please repeat your choice now?";
					 //return 3;
					 }
		 } 
	 }
	 output.confidence=res.confidence;
	 //printf("\n%f",output.confidence);
	 strcpy(temp,res.word.c_str());
	 
	 output.word=temp;
	 //printf("\n%s",output.word);
	 textToSpeech.play(&s);
	 res=reco(seconds, sample_rate, frames_per_buffer,p);

		if(yesno_answer)
				{
					while(res.confidence<=0.05)
						{
						  //s="Sorry I did not hear your answer. Please say yes or no.";
							s="I did not hear your answer. Please repeat yes or no.";
						  textToSpeech.play(&s);
						  res=reco(seconds, sample_rate, frames_per_buffer,p);
						}
					if(!strcmp(res.word.c_str(),"Yes"))
						{
							setChoice(UpToLow(output.word));
						}
					else
						{
						  yesno_answer=false;
						  speechRec.app=speechRec.MapBinaryFileToMem("Transcriptions.app",&length);
						  speechRec.rc=EarReadVocabulary(speechRec.ear, speechRec.app);                      // load grammatical model
						  s="Okay, we start the vote procedure again";
						  textToSpeech.play(&s);
						  tts();
						  res=reco(seconds, sample_rate, frames_per_buffer,p);
						}
				}
			 //setChoice(UpToLow(res.word)); //setting the recognized word as choice
			 
				 //display the result
			 if(!yesno_answer)
				{
				 setChoice(UpToLow(res.word)); //setting the recognized word as choice
				}
		  
	 //setChoice(UpToLow(res.word)); //setting the recognized word as choice
	 
		 //display the result
	 //setChoice(UpToLow(res.word)); //setting the recognized word as choice
  }
  
  free(temp);
  //output=reco(seconds, sample_rate, frames_per_buffer);
  resultat=getChoice();
  c=resultat.c_str();
  printf("\nWord recognized with high confidence\nChoice: %s, confidence:%f\n",c,res.confidence);
  /*delete[] s;
  delete[] resultat;
  delete[] output.word;*/
  return res;
}