#pragma once

#include <string>
#include <iostream>
#include <stdlib.h>
#include <fstream>
#include "cTextVote.h"
using namespace std;
#include<stdio.h>
//#include<winsock2.h>
//#pragma comment(lib,"ws2_32.lib")
#pragma comment(lib, "ear.lib")
#include "portaudio.h"
#include "ear.h"



#define CHECK(x) if ((rc = x) != EarNoError) {fprintf(stderr,"Error in %s : %s\n",#x,(char*)EarErrorString(rc));}

#define EAR_DL_IMPORT _declspec(dllimport)


typedef short SAMPLE;
#define SAMPLE_SILENCE  (0)
#define PRINTF_S_FORMAT "%d"
#define NUM_CHANNELS 1


#ifdef  __cplusplus
extern "C" {
#endif

extern EAR_DL_IMPORT LPEAR EarOpen();
extern EAR_DL_IMPORT EarReturnCode EarClose(LPEAR);
extern EAR_DL_IMPORT EarReturnCode EarSetSetting(LPEAR, EarParam, double);
extern EAR_DL_IMPORT int EarRecognizedWordCount(LPEAR, int);
extern EAR_DL_IMPORT const char* EarRecognizedWord(LPEAR, int, int);
extern EAR_DL_IMPORT EarReturnCode EarPopString(LPEAR);
extern EAR_DL_IMPORT LPEARMODELS EarModels(const char*);
extern EAR_DL_IMPORT LPEARMODELS EarModelsOpen(EarDataType, EarDataType, const char*, char*);
extern EAR_DL_IMPORT EarReturnCode EarModelsClose(LPEARMODELS);
extern EAR_DL_IMPORT EarReturnCode EarSetModels(LPEAR, LPEARMODELS);
extern EAR_DL_IMPORT EarReturnCode EarModelsSetVocabulary(LPEARMODELS, LPEARVOC);
extern EAR_DL_IMPORT EarReturnCode EarReadVocabulary(LPEAR, const char*);
extern EAR_DL_IMPORT LPEARVOC EarVocabularyOpen(const char*, char*);
extern EAR_DL_IMPORT const char* EarErrorString(EarReturnCode);
extern EAR_DL_IMPORT float EarRecognizedConfidenceLevel(LPEAR, int, int);
extern EAR_DL_IMPORT EarReturnCode EarStopRecognition(LPEAR);
extern EAR_DL_IMPORT EarReturnCode EarGetRecognizedString(LPEAR, const char ***,int**,float**,int**);
extern EAR_DL_IMPORT EarReturnCode EarGetNBestStrings(LPEAR, const char****, int***, float***, int***);
extern EAR_DL_IMPORT EarReturnCode EarVocabularyClose(LPEARVOC);
extern EAR_DL_IMPORT EarReturnCode EarRecognizeBuffer(LPEAR, const void *, int);
extern EAR_DL_IMPORT EarReturnCode EarProcessSamples(LPEAR, const void *, int);

#ifdef  __cplusplus
}
#endif

typedef struct
{
    int          frameIndex;  /* Index into sample array. */
	int          maxFrameIndex;
    SAMPLE      *recordedSamples;
  //string *s;
}param;

typedef struct 
{
  string word;
  float confidence;
}results;

class speech_rec:public cTextVote
{
public:
	speech_rec(string *keywords, int nbr_keywords, float seconds, int Speech_det, int Sample_rate, int frames_per_buffer, param* p);
	speech_rec();
	~speech_rec(void);

	static bool create_gram(string *keywords, int nbr_keywords,char* dictname, char* out_name);
	//string BG_StringToUpper (const string sBGString);
	bool set_rec_ready(float seconds, int Speech_det, int Sample_rate, int frames_per_buffer, param* p);
	results do_rec(float seconds, int sample_rate, int frames_per_buffer,param *p);
	bool initialise_ear(int speech_det);
	bool initialise_pa(float seconds, int Sample_rate, int frames_per_buffer, param* p);
	//SOCKET create_socket();
	void close_pa();
	results give_recognition_results();
	/*int piloteCallback( const void *inputBuffer, void *outputBuffer,
                           unsigned long framesPerBuffer,
                           const PaStreamCallbackTimeInfo* timeInfo,
                           PaStreamCallbackFlags statusFlags,
                           void *userData );*/
	//struct param;
	results terminate_recognition();
	int close_ear();
	bool init(string *keywords, int nbr_keywords, float seconds, int Speech_det, int Sample_rate, int frames_per_buffer, param* p);

	char *app;
	char* MapBinaryFileToMem(const char *fname, unsigned int *bufsize);
	EarReturnCode rc;
	LPEAR ear;
	LPEARMODELS	mlp;

private:
	PaStream *stream;
	//int nbuffers;
	bool isempty(const char *str);
	
	//struct param *p;
};
