#include "StdAfx.h"
#include "text_to_speech.h"

text_to_speech::text_to_speech(void):pVoice(NULL)
{
	initialise_SDK();
}

text_to_speech::~text_to_speech(void)
{
}

wchar_t* text_to_speech::string_to_wchar(string *r) //converts string to wchar_t
{
	const char *v=r->c_str();
	char *s=(char*)malloc(strlen(v)*sizeof(char));
	
	strcpy(s,v);
	//printf("taille=%d s=%s",strlen(v),s);
  locale loc1 ( "English" );
  wchar_t* g=(wchar_t *)malloc(strlen(v)*sizeof(wchar_t));
  bool result1 = (std::use_facet<ctype<wchar_t> > ( loc1 )._Widen_s
      ( s, s + strlen(v), &g[0],(strlen(v)*sizeof(wchar_t))) != 0);
  g[strlen(v)] = '\0';
  return g;
}

HRESULT text_to_speech::play(string *s)  //play string with Microsoft SDK
{
  wchar_t* w;
  w=string_to_wchar(s);
  return pVoice->Speak(w, 0, NULL);
}

void text_to_speech::make_question(string question,string *options,int nbr_options,string*toplay) //build the string to be played for our application by concatenating the question and the options and an invitation to vote
{
  int i;
  
  const char *x=question.c_str();
  int total_length=(int)strlen(x);
  for(i=0;i<nbr_options;i++)
	{
	  total_length+=(int)options[i].length();
	}
  total_length+=(2*nbr_options);

  char *c=(char*)malloc(total_length*sizeof(char*));
  strcpy(c,x);
  strcat(c,"\nThe options are:\n");
  
  for(i=0;i<nbr_options;i++)
	{
	if(i==(nbr_options-1))
		{
			strcat(c,"And ");
		}
	  strcat(c,options[i].c_str());
	  strcat(c,".\n");
	}
  strcat(c,"\nPlease vote now");
  *toplay=c;
  //free(c);
  /*string d=c;
  return &d;*/
}


HRESULT text_to_speech::initialise_SDK(void)  // initialise Microsoft Speech SDK
{
CComPtr<ISpStream>  cpWavStream;
	//CComPtr<ISpStreamFormat>    cpOldStream;
	long pRate=0;
	//WCHAR *c, *d;

	HRESULT hr=CoInitialize(NULL);
    if (FAILED(hr))
        return FALSE;

    hr = CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&pVoice);
	
	if(SUCCEEDED(hr))
	{
		pRate=-1;
		hr=pVoice->SetRate(pRate);
	}
	return hr;
}
