// Commun.h: interface for the CCommun class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMUN_H__BF134BBC_56BE_48CB_BCCF_0BD33020DFE3__INCLUDED_)
#define AFX_COMMUN_H__BF134BBC_56BE_48CB_BCCF_0BD33020DFE3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "cv.h"
#include "highgui.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <time.h>
#include <ctype.h>

class CCommun  
{
public:
	CCommun();
	virtual ~CCommun();
	static inline void scaleCvRect(CvRect * head,double wScale,double hScale){
		int neww=(int)(head->width*wScale);
		int newh=(int)(head->height*hScale);
		int newx=(int)(head->x-(neww-head->width)/2);
		int newy=(int)(head->y-(newh-head->height)/2);
		head->x=newx;
		head->y=newy;
		head->height=newh;
		head->width=neww;
	}
	static inline ULONGLONG getCurrentTimeInMs(){
		SYSTEMTIME systemTime;
		GetSystemTime( &systemTime );
		FILETIME fileTime;
		SystemTimeToFileTime( &systemTime, &fileTime );

		ULARGE_INTEGER uli;
		uli.LowPart = fileTime.dwLowDateTime; // could use memcpy here!
		uli.HighPart = fileTime.dwHighDateTime;

		ULONGLONG systemTimeIn_ms( uli.QuadPart/10000 );
		return systemTimeIn_ms;
	}
	static inline bool insideTest(CvRect & rBig,CvRect & rSmall){
		return rBig.x<rSmall.x&&(rBig.x+rBig.width)>(rSmall.x+rSmall.width)&&rBig.y<rSmall.y&&(rBig.y+rBig.height)>(rSmall.y+rSmall.height);
	}
};

#endif // !defined(AFX_COMMUN_H__BF134BBC_56BE_48CB_BCCF_0BD33020DFE3__INCLUDED_)
