// CvPointList.cpp: implementation of the CCvPointList class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "CvPointList.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCvPointList::CCvPointList():m_CvPoints(){}

CCvPointList::~CCvPointList(){}

void CCvPointList::getAveragePoints(COpenCvImage* frame,int minx,int miny,int maxx,int maxy,int validationPourcentage,int validationZoneH,int validationZoneW){
	uchar Y;
	uchar * ptr_frame;
	int x=0,y=0,my=0,mx=0,cpt=0;

	if(minx<0){minx=0;}
	if(maxx>frame->width()){maxx=frame->width();}
	if(miny<0){miny=0;}
	if(maxy>frame->height()){maxy=frame->height();}
	
	for( y=miny;y<maxy; y++){
		for ( x=minx; x<maxx; x++){
			ptr_frame = frame->cvMoveTo(x,y);
			Y = ptr_frame[0];
			if(Y!=0){
				cpt++;
				my+=y;
				mx+=x;
			}
		}
	}
	if(cpt!=0){
		int dstx=(int)(mx/cpt);
		int dsty=(int)(my/cpt);

		if(testZone(frame,validationPourcentage,dstx,dsty,dstx+validationZoneW,dsty+validationZoneH)){
			CvPoint dst;
			dst.x=dstx;
			dst.y=dsty;
			m_CvPoints.push_back(dst);
		}else if(maxx-minx>validationZoneW&&maxy-miny>validationZoneH){
			if(dstx==minx){dstx+=1;}
			if(dsty==miny){dsty+=1;}
			if(dstx==maxx){dstx-=1;}
			if(dsty==maxy){dsty-=1;}
			int newx=dstx;
			int newy=dsty;
			getAveragePoints(frame,minx,miny,newx,newy,validationPourcentage,validationZoneH,validationZoneW);
			getAveragePoints(frame,newx,miny,maxx,newy,validationPourcentage,validationZoneH,validationZoneW);
			getAveragePoints(frame,minx,newy,newx,maxy,validationPourcentage,validationZoneH,validationZoneW);
			getAveragePoints(frame,newx,newy,maxx,maxy,validationPourcentage,validationZoneH,validationZoneW);
		}
	}
}

bool CCvPointList::testZone(COpenCvImage* skinMask,double pourcentage,int minx,int miny,int maxx,int maxy){
	uchar * ptr_skinMask;
	int x=0,y=0;
	int nbrPixelOn=0;
	int nbrPixel=0;

	if(minx<0){minx=0;}
	if(maxx>skinMask->width()){maxx=skinMask->width();}
	if(miny<0){miny=0;}
	if(maxy>skinMask->height()){maxy=skinMask->height();}

	for( y=miny;y<maxy; y++){
		for ( x=minx; x<maxx; x++){
			ptr_skinMask = skinMask->cvMoveTo(x,y);
			if( ptr_skinMask[0] == 255 ){
				nbrPixelOn++;
			}
			nbrPixel++;
		}
	}
	return pourcentage/100.0<(double)nbrPixelOn/(double)(nbrPixel);
}

CvPoint CCvPointList::getCloserCvPoint(int x, int y){
	std::vector<CvPoint>::iterator iter;
	CvPoint min;
	min.x=-1;
	min.y=-1;
	int distanceCourante=-1;
	for (iter=m_CvPoints.begin(); iter != m_CvPoints.end(); iter++){
		if(min.x=-1){
			min.x=iter->x;
			min.y=iter->y;
			int dx=iter->x-x;
			int dy=iter->y-y;
			int distanceCourante=dx*dx+dy*dy;
		}else{
			int dx=iter->x-x;
			int dy=iter->y-y;
			int distance=dx*dx+dy*dy;
			if(distanceCourante>distance){
				distanceCourante=distance;
				min.x=iter->x;
				min.y=iter->y;
			}
		}
	}
	return min;
}