#include "StdAfx.h"
#include ".\cvrectlist.h"

CCvRectList::CCvRectList(void):m_CvRects()
{
}

CCvRectList::~CCvRectList(void)
{
}

void CCvRectList::addCvRectsFromMask(COpenCvImage* mask,CvRect zone,int validationPourcentage,int cvRectWidth,int cvRectHeight){
	addCvRectsFromMask(mask,zone.x,zone.y,zone.x+zone.width,zone.y+zone.height,validationPourcentage,cvRectWidth,cvRectHeight);
}

void CCvRectList::addCvRectsFromMask(COpenCvImage* mask,int minx,int miny,int maxx,int maxy,int validationPourcentage,int cvRectWidth,int cvRectHeight){
	uchar Y;
	uchar * ptr_frame;
	int x=0,y=0,my=0,mx=0,cpt=0;

	if(minx<0){minx=0;}
	if(maxx>mask->width()){maxx=mask->width();}
	if(miny<0){miny=0;}
	if(maxy>mask->height()){maxy=mask->height();}
	
	for( y=miny;y<maxy; y++){
		for ( x=minx; x<maxx; x++){
			ptr_frame = mask->cvMoveTo(x,y);
			Y = ptr_frame[0];
			if(Y!=0){
				cpt++;
				my+=y;
				mx+=x;
			}
		}
	}
	if(cpt!=0){
		int dstx=(int)(mx/cpt);
		int dsty=(int)(my/cpt);
		CvRect res;
		res.x=dstx-cvRectWidth/2;
		res.y=dsty-cvRectHeight/2;
		res.width=cvRectWidth;
		res.height=cvRectHeight;

		if(mask->testMaskZone(validationPourcentage,res)){
			m_CvRects.push_back(res);
		}else if(maxx-minx>cvRectWidth&&maxy-miny>cvRectHeight){
			if(dstx==minx){dstx+=1;}
			if(dsty==miny){dsty+=1;}
			if(dstx==maxx){dstx-=1;}
			if(dsty==maxy){dsty-=1;}
			int newx=dstx;
			int newy=dsty;
			addCvRectsFromMask(mask,minx,miny,newx,newy,validationPourcentage,cvRectWidth,cvRectHeight);
			addCvRectsFromMask(mask,newx,miny,maxx,newy,validationPourcentage,cvRectWidth,cvRectHeight);
			addCvRectsFromMask(mask,minx,newy,newx,maxy,validationPourcentage,cvRectWidth,cvRectHeight);
			addCvRectsFromMask(mask,newx,newy,maxx,maxy,validationPourcentage,cvRectWidth,cvRectHeight);
		}
	}
}

CvRect CCvRectList::getCloserCvRect(int x, int y){
	std::vector<CvRect>::iterator iter;
	CvRect min;
	min.x=-1;
	min.y=-1;
	int distanceCourante=-1;
	for (iter=m_CvRects.begin(); iter != m_CvRects.end(); iter++){
		if(min.x=-1){
			min.x=iter->x;
			min.y=iter->y;
			min.width=iter->width;
			min.height=iter->height;
			int dx=iter->x-x;
			int dy=iter->y-y;
			distanceCourante=dx*dx+dy*dy;
		}else{
			int dx=iter->x-x;
			int dy=iter->y-y;
			int distance=dx*dx+dy*dy;
			if(distanceCourante>distance){
				distanceCourante=distance;
				min.x=iter->x;
				min.y=iter->y;
				min.width=iter->width;
				min.height=iter->height;
			}
		}
	}
	return min;
}