// DeltaColor.cpp: implementation of the CDeltaColor class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "DeltaColor.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDeltaColor::CDeltaColor():min(255,255,255),max(0,0,0),cpt(0){}

CDeltaColor::~CDeltaColor(){}

bool CDeltaColor::test(CYCrCb color){
	return test(color.Y,color.Cr,color.Cb);
}
bool CDeltaColor::test(unsigned char Y,unsigned char Cr,unsigned char Cb){
	return 
		Y>=min.Y&&Y<=max.Y&&
		Cr>=min.Cr&&Cr<=max.Cr&&
		Cb>=min.Cb&&Cb<=max.Cb;
}

bool CDeltaColor::test(unsigned char Y,unsigned char Cr,unsigned char Cb,int p){
	int dY=((max.Y-min.Y)*p)/100;
	int dCr=((max.Cr-min.Cr)*p)/100;
	int dCb=((max.Cb-min.Cb)*p)/100;
	int dtY=Y-average.Y;if(dtY<0){dtY=-dtY;}
	int dtCr=Cr-average.Cr;if(dtCr<0){dtCr=-dtCr;}
	int dtCb=Cb-average.Cb;if(dtCb<0){dtCb=-dtCb;}
	return test(Y,Cr,Cb)&&dY>dtY&&dCr>dtCr&&dCb>dtCb;
}

void CDeltaColor::update(CYCrCb color){
	update(color.Y,color.Cr,color.Cb);
}

void CDeltaColor::update(unsigned char Y,unsigned char Cr,unsigned char Cb){
	if(min.Y>Y){min.Y=Y;}
	if(min.Cb>Cb){min.Cb=Cb;}
	if(min.Cr>Cr){min.Cr=Cr;}
	if(max.Y<Y){max.Y=Y;}
	if(max.Cb<Cb){max.Cb=Cb;}
	if(max.Cr<Cr){max.Cr=Cr;}
	average.Y=(unsigned char)((average.Y*cpt+Y)/(cpt+1));
	average.Cb=(unsigned char)((average.Cb*cpt+Cb)/(cpt+1));
	average.Cr=(unsigned char)((average.Cr*cpt+Cr)/(cpt+1));
	cpt++;
}
