#pragma once

#include "PeopleWithHands.h"
#include "Commun.h"

#define LEFT_POSITION -1
#define RIGHT_POSITION 1

class CHandPosition{
public:
	CHandPosition(CPeopleWithHands * peopleWithHands,int position):m_pPeopleWithHands(peopleWithHands),m_position(position){}
	~CHandPosition(void){}
	inline CHandPosition * getP(){return this;}
	CPeopleWithHands * m_pPeopleWithHands;
	int m_position;
};

class CHand{
public:
	CHand(CvRect & rectHand,CPeopleWithHands * peopleWithHands,int position):m_pPeoplesWithHands(){
		rect.x=rectHand.x;
		rect.y=rectHand.y;
		rect.width=rectHand.width;
		rect.height=rectHand.height;
		CHandPosition hp(peopleWithHands,position);
		m_pPeoplesWithHands.push_back(hp);
	}
	~CHand(void){}
	inline bool is(CvRect & rectHand){
		return rect.x==rectHand.x&&rect.y==rectHand.y&&rect.width==rectHand.width&&rect.height==rectHand.height;
	}
	inline bool is(CvRect & rectHand,int delta){
		int dx=(rect.x+rect.width/2)-(rectHand.x+rectHand.width/2);if(dx<0){dx=-dx;}
		int dy=(rect.y+rect.height/2)-(rectHand.y+rectHand.width/2);if(dy<0){dy=-dy;}

		return 
			dx<=delta&&
			dy<=delta/*&&
			rect.width==rectHand.width&&
			rect.height==rectHand.height*/;
	}
	inline bool addIfIsTheSame(CvRect & rectHand,CPeopleWithHands * peopleWithHands,int position){
		if(is(rectHand,rectHand.width/3)){
			CHandPosition hp(peopleWithHands,position);
			m_pPeoplesWithHands.push_back(hp);
			return true;
		}else{
			return false;
		}
	}
	inline int distanceTo(CHandPosition * handPosition){
		int d=-1;
		CPeopleWithHands * p=handPosition->m_pPeopleWithHands;
		if(handPosition->m_position==LEFT_POSITION){
			int dx=(rect.x+rect.width/2)-(p->m_head.x+p->m_head.width);//if(dx<0){dx=-dx;}
			int dy=(rect.y+rect.height/2)-(p->m_head.y+p->m_head.height/2);//if(dy<0){dy=-dy;}
			d=dx*dx+dy*dy;
		}else if(handPosition->m_position==RIGHT_POSITION){
			int dx=(rect.x+rect.width/2)-(p->m_head.x);//if(dx<0){dx=-dx;}
			int dy=(rect.y+rect.height/2)-(p->m_head.y+p->m_head.height/2);//if(dy<0){dy=-dy;}
			d=dx*dx+dy*dy;
		}
		return d;
	}

	inline void associateTo(CHandPosition * handPosition){
		int position=handPosition->m_position;
		CPeopleWithHands * peopleWithHands=handPosition->m_pPeopleWithHands;
		if(position==LEFT_POSITION){
			peopleWithHands->m_leftHand.x=rect.x;
			peopleWithHands->m_leftHand.y=rect.y;
			//peopleWithHands->m_leftHand.width=rect.width;
			//peopleWithHands->m_leftHand.height=rect.height;
		}else if(position==RIGHT_POSITION){
			peopleWithHands->m_rightHand.x=rect.x;
			peopleWithHands->m_rightHand.y=rect.y;
			//peopleWithHands->m_rightHand.width=rect.width;
			//peopleWithHands->m_rightHand.height=rect.height;
		}
	}

	CvRect rect;
	std::vector<CHandPosition> m_pPeoplesWithHands;
};

class CHandList
{
public:
	CHandList(void):m_Hands(){}
	~CHandList(void){}
	inline void add(CvRect rectHand,CPeopleWithHands * peopleWithHands,int position){
		bool alreadyExist=false;
		std::vector<CHand>::iterator iter;
		for (iter=m_Hands.begin(); iter != m_Hands.end()&&!alreadyExist; iter++){
			alreadyExist=iter->addIfIsTheSame(rectHand,peopleWithHands,position);
		}
		if(!alreadyExist){
			CHand h(rectHand,peopleWithHands,position);
			m_Hands.push_back(h);
		}
	}

	inline void associate(){
		std::vector<CHand>::iterator iter;
		for (iter=m_Hands.begin(); iter != m_Hands.end(); iter++){
			if(iter->m_pPeoplesWithHands.size()==1){
				iter->associateTo(iter->m_pPeoplesWithHands.begin()->getP());
			}
		}
		for (iter=m_Hands.begin(); iter != m_Hands.end(); iter++){
			if(iter->m_pPeoplesWithHands.size()!=1){
				CvRect rectHand=iter->rect;
				std::vector<CHandPosition>::iterator iterHandPosition;
				CHandPosition * handPositionWithNoHandsAndCloser=0;
				int distanceMin=-1;
				for (iterHandPosition=iter->m_pPeoplesWithHands.begin(); iterHandPosition != iter->m_pPeoplesWithHands.end(); iterHandPosition++){
					int position=iterHandPosition->m_position;
					CPeopleWithHands * peopleWithHands=iterHandPosition->m_pPeopleWithHands;
					if(!peopleWithHands->hasHands()){
						int distance=iter->distanceTo(iterHandPosition->getP());
						if(distanceMin==-1||distance<distanceMin){
							distanceMin=distance;
							handPositionWithNoHandsAndCloser=iterHandPosition->getP();
						}
					}
				}
				if(distanceMin!=-1){
					iter->associateTo(handPositionWithNoHandsAndCloser);
				}
			}
		}
	}
	std::vector<CHand> m_Hands;
};


