// OpenCvImage.h: interface for the COpenCvImage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPENCVIMAGE_H__3F76195F_9CAF_4161_8809_D929E1E09C63__INCLUDED_)
#define AFX_OPENCVIMAGE_H__3F76195F_9CAF_4161_8809_D929E1E09C63__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Commun.h"
#include "DeltaColor.h"

//

class COpenCvImage  
{
public:
	static int cptNamedWindow;
	COpenCvImage(CvSize size);
	COpenCvImage(IplImage* original);
	COpenCvImage(COpenCvImage * original);
	virtual ~COpenCvImage();
	void removeCvRect(CvRect * r);
	void reset();
	void fillZone(CvRect r,unsigned char value);
	void fillZone(int minx,int maxx,int miny,int maxy,unsigned char value);
	//bool testZone(double pourcentage,int minx,int miny,int maxx,int maxy);
	void skinMask(COpenCvImage * src_RGB);
	void skinMask(COpenCvImage * src_RGB,CDeltaColor dc);
	void mvtMask(COpenCvImage * srcRGBOld, COpenCvImage * srcRGBNew, int threshold);
	void deltaColorMask(COpenCvImage * src_RGB,CDeltaColor deltaColor);
	void removeNoise();
	CvPoint getAverageCvPoint(CvRect * maskZone);

	bool testMaskZone(double pourcentage,CvRect zone);
	bool testMaskZone(double pourcentage,int minx,int miny,int maxx,int maxy);

	inline int height(){return im->height;}
	inline int width(){return im->width;}
	inline CvSize size(){return cvGetSize(im);}
	inline void showImage(){
		if(!namedWindows){
			namedWindows=getIdNamedWindows();
			cvNamedWindow(namedWindows,1);
		}
		cvShowImage( namedWindows, im );
	}
	inline void setAsCvAnd(COpenCvImage * openCvImage1, COpenCvImage * openCvImage2){
		cvAnd( openCvImage1->im, openCvImage2->im, im ,0);
	}
		
	inline void copy(COpenCvImage cOpenCvImage){
		if( cOpenCvImage.im->origin == IPL_ORIGIN_TL ){
			cvCopy( cOpenCvImage.im, im, 0 );
		}else{
			cvFlip( cOpenCvImage.im, im, 0 );
		}
	}
	inline void erode(int erosions){
		if(erosions>0) cvErode(im,im,0,erosions);
	}
	inline void dilate(int dilations){
		if (dilations>0) cvDilate(im,im,0,dilations);
	}

	inline void drawCvRect(CvRect * r,CvScalar color){
		CvPoint pt1,pt2;
		pt1.x = r->x;
		pt2.x = r->x+r->width;
		pt1.y = r->y;
		pt2.y = r->y+r->height;
		cvRectangle(im,pt1,pt2,color, 3, 8 ,0);
	}


	void setImage(IplImage* original);
	uchar * cvMoveTo(int x,int y);

//static
	static COpenCvImage * getMvtImage(COpenCvImage * srcRGBOld, COpenCvImage * srcRGBNew, int threshold);
	static COpenCvImage * getSkinMask(COpenCvImage * src);
	
	//static int cptNamedWindow;
	static inline char * getIdNamedWindows(){
		char * str=new char[255];
		sprintf(str,"NamedWindows%d",cptNamedWindow++);
		return str;
	}
	IplImage* im;
private:
	void initPixelPos();
	CvPixelPosition8u pos;
	char * namedWindows;
};

#endif // !defined(AFX_OPENCVIMAGE_H__3F76195F_9CAF_4161_8809_D929E1E09C63__INCLUDED_)
