// OpenCvTracker.cpp: implementation of the COpenCvTracker class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "OpenCvTracker.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COpenCvTracker::COpenCvTracker(COpenCvImage * originalMask,CvRect originalZone){
	m_originalMask=new COpenCvImage(originalMask);
	m_originalZone.x=originalZone.x;
	m_originalZone.y=originalZone.y;
	m_originalZone.height=originalZone.height;
	m_originalZone.width=originalZone.width;
}

COpenCvTracker::~COpenCvTracker(){
	if(m_originalMask){delete m_originalMask;}
}

void COpenCvTracker::track(COpenCvImage * mask,CvRect * outputZone){
	//specify the size needed by the match function
	int resultW = m_originalMask->width() - m_originalZone.width + 1;
	int resultH = m_originalMask->height() - m_originalZone.height +1;

	//create each of the result images
	IplImage* result = cvCreateImage(cvSize(resultW, resultH), IPL_DEPTH_32F, 1);

	cvSetImageROI(m_originalMask->im, m_originalZone );
	cvMatchTemplate( mask->im, m_originalMask->im,result, CV_TM_SQDIFF );
	cvResetImageROI(m_originalMask->im);

	double min_val,max_val;
	CvPoint min_loc,max_loc;
	cvMinMaxLoc( result, &min_val, &max_val, &min_loc, &max_loc, 0 );

	//printf("find : min_val=%d, max_val=%d, min_loc.x=%d, min_loc.y=%d, max_loc.x=%d, max_loc.y=%d",min_val, max_val, min_loc.x, min_loc.y, max_loc.x, max_loc.y);
	outputZone->x=(min_loc.x);
	outputZone->y=(min_loc.y);
}
//PAS BON POUR L'INSTANT !!!
void COpenCvTracker::trackIn(COpenCvImage * mask,CvRect * searchZone,CvRect * outputZone){
	//specify the size needed by the match function
	int resultW = m_originalMask->width() - m_originalZone.width + 1;
	int resultH = m_originalMask->height() - m_originalZone.height +1;

	//create each of the result images
	IplImage* result = cvCreateImage(cvSize(resultW, resultH), IPL_DEPTH_32F, 1);

	cvSetImageROI(m_originalMask->im, m_originalZone );
	cvSetImageROI(mask->im, *searchZone );
	cvMatchTemplate( mask->im, m_originalMask->im,result, CV_TM_SQDIFF );
	cvResetImageROI(m_originalMask->im);
	cvResetImageROI(mask->im);

	double min_val,max_val;
	CvPoint min_loc,max_loc;
	cvMinMaxLoc( result, &min_val, &max_val, &min_loc, &max_loc, 0 );

	//printf("find : min_val=%d, max_val=%d, min_loc.x=%d, min_loc.y=%d, max_loc.x=%d, max_loc.y=%d",min_val, max_val, min_loc.x, min_loc.y, max_loc.x, max_loc.y);
	outputZone->x=(min_loc.x);
	outputZone->y=(min_loc.y);
}

void COpenCvTracker::trackMaskZone2(COpenCvImage * oldMask,COpenCvImage * mask,CvRect * oldZone,CvRect * outputZone){
	uchar Y,YOld;
	uchar * ptr_oldMask;
	uchar * ptr_mask;
	int minx = oldZone->x;
	int maxx = oldZone->x+oldZone->width;
	int miny = oldZone->y;
	int maxy = oldZone->y+oldZone->height;
	if(minx<0){minx=0;}
	if(maxx>oldMask->width()){maxx=oldMask->width();}
	if(miny<0){miny=0;}
	if(maxy>oldMask->height()){maxy=oldMask->height();}
	
	int mxOld=0,myOld=0,cptOld=0;
	int borneInfxOld=maxx;
	int borneSupxOld=minx;
	int borneInfyOld=maxy;
	int borneSupyOld=miny;

	int mx=0,my=0,cpt=0;
	int borneInfx=maxx;
	int borneSupx=minx;
	int borneInfy=maxy;
	int borneSupy=miny;

	for(int y=miny;y<maxy; y++){
		for (int x=minx; x<maxx; x++){
			ptr_oldMask = oldMask->cvMoveTo(x,y);
			ptr_mask=mask->cvMoveTo(x,y);
			YOld = ptr_oldMask[0];
			Y = ptr_mask[0];
			if(YOld==255){
				if(x<borneInfxOld){borneInfxOld=x;}
				if(x>borneSupxOld){borneSupxOld=x;}
				if(y<borneInfyOld){borneInfyOld=y;}
				if(y>borneSupyOld){borneSupyOld=y;}
				cptOld++;myOld+=y;mxOld+=x;
			}
			if(Y==255){
				if(x<borneInfx){borneInfx=x;}
				if(x>borneSupx){borneSupx=x;}
				if(y<borneInfy){borneInfy=y;}
				if(y>borneSupy){borneSupy=y;}
				cpt++;my+=y;mx+=x;
			}
		}
	}

	//printf("borneInfxOld=%d borneSupxOld=%d borneInfyOld=%d borneSupyOld=%d borneInfx=%d borneSupx=%d borneInfy=%d borneSupy=%d\n",borneInfxOld, borneSupxOld,borneInfyOld, borneSupyOld, borneInfx, borneSupx, borneInfy, borneSupy);

	if(cpt>0&&cptOld>0){
		int dcptx=1;
		int dcpty=1;
		int dmx=mx/cpt-mxOld/cptOld;
		int dmy=my/cpt-myOld/cptOld;
		printf("dmx=%d dmy=%d",dmx,dmy);
		int dborneInfx=0;
		int dborneSupx=0;
		int dborneInfy=0;
		int dborneSupy=0;
		
		if(borneInfxOld!=minx&&borneInfx!=minx){
			dcptx++;dborneInfx=borneInfx-borneInfxOld;
		}
		if(borneSupxOld!=maxx&&borneSupx!=maxx){
			dcptx++;dborneSupx=borneSupx-borneSupxOld;
		}
		if(borneInfyOld!=miny&&borneInfy!=miny){
			dcpty++;dborneInfy=borneInfy-borneInfyOld;
		}
		if(borneSupyOld!=maxy&&borneSupy!=maxy){
			dcpty++;dborneSupy=borneSupy-borneSupyOld;
		}
		outputZone->x+=(dmx+dborneInfx+dborneSupx)/dcptx;
		outputZone->y+=(dmy+dborneInfy+dborneSupy)/dcpty;
		outputZone->height=oldZone->height;
		outputZone->width=oldZone->width;
	}
}


CvRect COpenCvTracker::trackMaskZone(COpenCvImage * oldMask,COpenCvImage * mask,CvRect * oldZone,CvRect * outputZone){

	CvRect zone;
	if(oldZone->x<0){zone.x=0;}else{zone.x=oldZone->x;}
	if(oldZone->x+oldZone->width>oldMask->width()){
		zone.width=oldMask->width()-zone.x;
	}else{
		zone.width=oldZone->width+(oldZone->x-zone.x);
	}
	if(oldZone->y<0){zone.y=0;}else{zone.y=oldZone->y;}
	if(oldZone->y+oldZone->height>oldMask->height()){
		zone.height=oldMask->height()-zone.y;
	}else{
		zone.height=oldZone->height+(oldZone->y-zone.y);
	}

	//specify the size needed by the match function
	int resultW = oldMask->width() - zone.width + 1;
	int resultH = oldMask->height() - zone.height +1;

	//create each of the result images
	IplImage* result = cvCreateImage(cvSize(resultW, resultH), IPL_DEPTH_32F, 1);

	cvSetImageROI(oldMask->im, zone );
	cvMatchTemplate( mask->im, oldMask->im,result, CV_TM_SQDIFF );
	cvResetImageROI(oldMask->im);

	double min_val,max_val;
	CvPoint min_loc,max_loc;
	cvMinMaxLoc( result, &min_val, &max_val, &min_loc, &max_loc, 0 );

	//printf("find : min_val=%d, max_val=%d, min_loc.x=%d, min_loc.y=%d, max_loc.x=%d, max_loc.y=%d",min_val, max_val, min_loc.x, min_loc.y, max_loc.x, max_loc.y);
	outputZone->x+=(min_loc.x-zone.x);
	outputZone->y+=(min_loc.y-zone.y);
	return zone;
}