// PeopleWithHands.h: interface for the CPeopleWithHands class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PEOPLEWITHHANDS_H__1A611E85_70CB_41ED_AFE1_39ED909EA945__INCLUDED_)
#define AFX_PEOPLEWITHHANDS_H__1A611E85_70CB_41ED_AFE1_39ED909EA945__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Commun.h"
#include "OpenCvImage.h"
#include "OpenCvTracker.h"
#include "CvPointList.h"
#include "CvRectList.h"
#include "SkinMask.h"

class CPeopleWithHands  
{
public:
	CPeopleWithHands(CvRect * head);
	virtual ~CPeopleWithHands();
	int distance(CvRect * r);
	bool updateHead(CvRect * head);
	void updateRLZone(COpenCvImage* frame);
	bool isTheSame(CvRect * r);
	void draw(COpenCvImage* frame, CvScalar color);
	void drawHead(COpenCvImage* frame,CvScalar color);
	void autoTrackingWithSkinMask(COpenCvImage * skinMaskOld,COpenCvImage * skinMask);
	void stupidHandsDetection(CSkinMask* skinMask);
	bool isInHandZone(CvRect & hand);
	CvRect getCloserRightHand(CSkinMask * skinMask);
	CvRect getCloserLeftHand(CSkinMask * skinMask);
	void setCloserHand(CCvRectList & cvRectList);
	bool getVote();
	bool inline hasHands(){
		return m_leftHand.x!=-1||m_rightHand.x!=-1;
	}
	CvRect getBodyCvRect();
	static void inline scaleHead(CvRect * head){
		CCommun::scaleCvRect(head,1.1,1.5);
	}
	inline CPeopleWithHands * getP(){
		return this;
	}
	void resetLR();
	CvRect m_head;
	CvRect m_leftZone;
	CvRect m_rightZone;
	CvRect m_leftHand;
	CvRect m_rightHand;

private :
	
	COpenCvTracker * m_openCvTracker;
};

#endif // !defined(AFX_PEOPLEWITHHANDS_H__1A611E85_70CB_41ED_AFE1_39ED909EA945__INCLUDED_)
