// PeopleWithHandsList.cpp: implementation of the CPeopleWithHandsList class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "PeopleWithHandsList.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPeopleWithHandsList::CPeopleWithHandsList(CCaptureFromCAM & captureFromCAM):m_dataSources(captureFromCAM),m_peoples(),faceDetector(),maskSkinOld(0),maskSkin(0),/*leftHandsResearchMask(0),rightHandsResearchMask(0),*/headsResearchMask(0),handsResearchMask(0){}

CPeopleWithHandsList::~CPeopleWithHandsList(){
	//if(leftHandsResearchMask){delete leftHandsResearchMask;}
	//if(rightHandsResearchMask){delete rightHandsResearchMask;}
	if(handsResearchMask){delete handsResearchMask;}
	if(maskSkinOld){delete maskSkinOld;}
	if(maskSkin){delete maskSkin;}
}

void CPeopleWithHandsList::update(unsigned int nbrOfPeopleToDetect){
	//Skin detection
	if(maskSkinOld){
		maskSkinOld->copy(maskSkin);
	}else{
		maskSkinOld=new CSkinMask(m_dataSources.frame_old,1,4);
	}
	
	if(maskSkin){
		maskSkin->update(m_dataSources.frame_current);
	}else{
		maskSkin=new CSkinMask(m_dataSources.frame_current,1,4);
	}
	updateHeadsResearchMask();
	if(m_peoples.size()<nbrOfPeopleToDetect){
		updateHeads(m_dataSources.frame_current,headsResearchMask,nbrOfPeopleToDetect);
	}
	autoTrackingHeadsZone(m_dataSources.frame_current,maskSkinOld,maskSkin);
	//stupidHandsDetection();
	handsDetection();
}

void CPeopleWithHandsList::updateHeads(COpenCvImage* frame,CSkinMask * skinMask,unsigned int nbrOfPeopleToDetect){
/*	if(!leftHandsResearchMask){leftHandsResearchMask=new COpenCvImage(frame->size());}
	if(!rightHandsResearchMask){rightHandsResearchMask=new COpenCvImage(frame->size());}
	if(!handsResearchMask){handsResearchMask=new COpenCvImage(frame->size());}*/
	CvSeq * faces=faceDetector.detectFace(frame->im);
	for(int i = 0; i < (faces ? faces->total : 0); i++ ){
		CvRect* head=(CvRect*)cvGetSeqElem(faces,i);
		CPeopleWithHands::scaleHead(head);
		
		if(headsResearchMask->testMaskZone(40,*head)&&m_peoples.size()<nbrOfPeopleToDetect){
			std::list<CPeopleWithHands>::iterator iter=0;
			std::list<CPeopleWithHands>::iterator iterLePluProche=0;
			double distanceMin=-1;
			for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
				if(distanceMin==-1){
					distanceMin=iter->distance(head);
					iterLePluProche=iter;
				}else{
					double d=iter->distance(head);
					if(distanceMin>d){
						distanceMin=d;
						iterLePluProche=iter;
					}
				}
				
			}
			bool alreadyExist=false;
			if(iterLePluProche!=0){
				alreadyExist=iterLePluProche->updateHead(head);
			}
			if(!alreadyExist){
				CPeopleWithHands p(head);
				m_peoples.push_back(p);
			}
		}
	}
}

void CPeopleWithHandsList::autoTrackingHeadsZone(COpenCvImage * frame,COpenCvImage * skinMaskOld,CSkinMask * skinMask){
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		bool ok=faceDetector.trackFace(frame->im,&(iter->m_head),skinMask);//iter->autoTrackingWithSkinMask(skinMaskOld,skinMask);
		if(!ok){
			ok=faceDetector.trackFaceWithSkin(skinMaskOld, skinMask,&(iter->m_head));
		}
	}
}

void CPeopleWithHandsList::autoTrackingHeads(COpenCvImage * frame){
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		faceDetector.trackFace(frame->im,&(iter->m_head));//iter->autoTrackingWithSkinMask(skinMaskOld,skinMask);
	}
}

void CPeopleWithHandsList::autoTrackingWithSkinMask(COpenCvImage * skinMaskOld,COpenCvImage * skinMask){
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->autoTrackingWithSkinMask(skinMaskOld,skinMask);
	}
}
/*
void CPeopleWithHandsList::stupidHandsDetection(COpenCvImage* skinMask){
	COpenCvImage andskinMask(skinMask->size());
	andskinMask.setAsCvAnd(skinMask,handsResearchMask);
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->stupidHandsDetection(&andskinMask);
	}
}*/

bool CPeopleWithHandsList::handIsShared(CvRect & hand){
	int nbrShare=0;
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end()&&nbrShare<2; iter++){
		if(iter->isInHandZone(hand)){
			nbrShare++;
		}
	}
	return nbrShare!=1;
}

void CPeopleWithHandsList::handsDetection(){
	updateHandsResearchMask();

	CHandList hlist;
	//0.List of all hands
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->resetLR();
		CvRect rightHand=iter->getCloserRightHand(handsResearchMask);
		if(rightHand.x!=-1){
			hlist.add(rightHand,iter->getP(),RIGHT_POSITION);
		}
		CvRect leftHand=iter->getCloserLeftHand(handsResearchMask);
		if(leftHand.x!=-1){
			hlist.add(leftHand,iter->getP(),LEFT_POSITION);
		}
	}
	hlist.associate();
	/*
	std::list<CPeopleWithHands>::iterator iter;

	//0.List of all hands
	CCvRectList cvRectListTotale;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->resetLR();
		CvRect rightHand=iter->getCloserRightHand(handsResearchMask);
		if(rightHand.x!=-1){
			if(handIsShared(rightHand)){
				cvRectListTotale.m_CvRects.push_back(rightHand);
			}else{
				iter->m_rightHand.x=rightHand.x;
				iter->m_rightHand.y=rightHand.y;
			}
			handsResearchMask->removeCvRect(&iter->m_rightHand);
		}
		CvRect leftHand=iter->getCloserLeftHand(handsResearchMask);
		if(leftHand.x!=-1){
			if(handIsShared(leftHand)){
				cvRectListTotale.m_CvRects.push_back(leftHand);
			}else{
				iter->m_leftHand.x=leftHand.x;
				iter->m_leftHand.y=leftHand.y;
			}
			handsResearchMask->removeCvRect(&iter->m_leftHand);
		}
	}
	
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		if(!iter->hasHands()){
			iter->setCloserHand(cvRectListTotale);
		}
	}*/
}

void CPeopleWithHandsList::stupidHandsDetection(){
	updateHandsResearchMask();
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->stupidHandsDetection(handsResearchMask);
	}
}

void CPeopleWithHandsList::drawHeads(COpenCvImage* frame){
	std::list<CPeopleWithHands>::iterator iter;
	int i=0;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->drawHead(frame,colors[i%8]);
		i++;
	}
}

void CPeopleWithHandsList::draw(COpenCvImage* frame){
	std::list<CPeopleWithHands>::iterator iter;
	int i=0;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->draw(frame,colors[i%8]);
		i++;
	}
}

int CPeopleWithHandsList::getNbrOfYesVote(){
	int cptYes=0;
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		if(iter->getVote()){
			cptYes++;
		}
	}
	return cptYes;
}

void CPeopleWithHandsList::updateHeadsResearchMask(){
	if(!headsResearchMask){
		headsResearchMask=new CSkinMask(m_dataSources.frame_old,1,2);
	}
	headsResearchMask->copy(maskSkin);
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		CvRect body=iter->getBodyCvRect();
		headsResearchMask->fillZone(body,0);
		if(iter->m_leftHand.x!=-1){
			headsResearchMask->fillZone(iter->m_leftHand,0);
		}
		if(iter->m_rightHand.x!=-1){
			headsResearchMask->fillZone(iter->m_rightHand,0);
		}
	}
	headsResearchMask->showImage();
}

void CPeopleWithHandsList::updateHandsResearchMask(){
	if(!handsResearchMask){
		handsResearchMask=new CSkinMask(m_dataSources.frame_old,1,2);
	}
	COpenCvImage temps(handsResearchMask->size());
	temps.reset();
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->updateRLZone(&temps);
		temps.fillZone(iter->m_leftZone,255);
		temps.fillZone(iter->m_rightZone,255);
	}
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		temps.fillZone(iter->m_head,0);
		CvRect body=iter->getBodyCvRect();
		temps.fillZone(body,0);
	}
	handsResearchMask->setAsCvAnd(maskSkin,&temps);
	handsResearchMask->showImage();
}

/*
void CPeopleWithHandsList::updateHandsResearchMask(){
	rightHandsResearchMask->reset();
	leftHandsResearchMask->reset();
	handsResearchMask->reset();
	std::list<CPeopleWithHands>::iterator iter;
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		iter->updateRLZone(leftHandsResearchMask);
		leftHandsResearchMask->fillZone(iter->m_leftZone,255);
		rightHandsResearchMask->fillZone(iter->m_rightZone,255);
		handsResearchMask->fillZone(iter->m_leftZone,255);
		handsResearchMask->fillZone(iter->m_rightZone,255);
	}
	
	for (iter=m_peoples.begin(); iter != m_peoples.end(); iter++){
		leftHandsResearchMask->fillZone(iter->m_head,0);
		rightHandsResearchMask->fillZone(iter->m_head,0);
		handsResearchMask->fillZone(iter->m_head,0);
		CvRect body=iter->getBodyCvRect();
		leftHandsResearchMask->fillZone(body,0);
		rightHandsResearchMask->fillZone(body,0);
		handsResearchMask->fillZone(body,0);
	}
	//rightHandsResearchMask->showImage();
	//leftHandsResearchMask->showImage();
	handsResearchMask->showImage();
}*/