// PeopleWithHandsList.h: interface for the CPeopleWithHandsList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PEOPLEWITHHANDSLIST_H__37D01129_2077_4047_85C5_41939818BA4A__INCLUDED_)
#define AFX_PEOPLEWITHHANDSLIST_H__37D01129_2077_4047_85C5_41939818BA4A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <list>
#include "PeopleWithHands.h"
#include "FaceDetection.h"
#include "Commun.h"
#include "OpenCvImage.h"
#include "SkinMask.h"
#include "CaptureFromCAM.h"
#include "HandList.h"

static CvScalar colors[] = {
	{{0,0,255}},
	{{0,128,255}},
	{{0,255,255}},
	{{0,255,0}},
	{{255,128,0}},
	{{255,255,0}},
	{{255,0,0}},
	{{255,0,255}}
};

class CPeopleWithHandsList  
{
public:
	CPeopleWithHandsList(CCaptureFromCAM & captureFromCAM);
	virtual ~CPeopleWithHandsList();
	void update(unsigned int nbrOfPeopleToDetect);
	void updateHeads(COpenCvImage* frame,CSkinMask * skinMask,unsigned int nbrOfPeopleToDetect);
	void autoTrackingHeads(COpenCvImage * frame);
	void autoTrackingHeadsZone(COpenCvImage * frame,COpenCvImage * skinMaskOld,CSkinMask * skinMask);
	void autoTrackingWithSkinMask(COpenCvImage * skinMaskOld,COpenCvImage * skinMask);
	bool handIsShared(CvRect & hand);
	void handsDetection();
	void stupidHandsDetection();
	void drawHeads(COpenCvImage* frame);
	void draw(COpenCvImage* frame);
	int getNbrOfYesVote();
	std::list<CPeopleWithHands> m_peoples;

private:
	CCaptureFromCAM & m_dataSources;
	void updateHandsResearchMask();
	void updateHeadsResearchMask();

	CFaceDetection faceDetector;

	CSkinMask * maskSkinOld;
	CSkinMask * maskSkin;
	//COpenCvImage * maskMvt;
	//COpenCvImage * maskSkinMvt;

	//COpenCvImage * leftHandsResearchMask;
	//COpenCvImage * rightHandsResearchMask;
	CSkinMask * handsResearchMask;

	CSkinMask * headsResearchMask;
};

#endif // !defined(AFX_PEOPLEWITHHANDSLIST_H__37D01129_2077_4047_85C5_41939818BA4A__INCLUDED_)
